Function initSprites(sprite.typeSprite)
	initBricks sprite

	For i = 1 To starsMax
		sprite.typeSprite = New typeSprite	
		initSpriteStar sprite		
	Next

	sprite.typeSprite = New typeSprite	
	initSpriteBall sprite

	sprite.typeSprite = New typeSprite	
	initSpritePlayer sprite
End Function

Function initSpriteBulletExtraSuper(spriteB.typeSprite)
	sprite.typeSprite = New typeSprite
	initSpriteBulletExtra spriteB, sprite
	sprite\targetX = spriteB\x + spriteB\width / 2 - spriteB\width - sprite\width / 2
	
	sprite.typeSprite = New typeSprite
	initSpriteBulletExtra spriteB, sprite
	sprite\targetX = spriteB\x + spriteB\width / 2 + spriteB\width - sprite\width / 2
End Function

Function initSpriteBulletExtra(spriteB.typeSprite, sprite.typeSprite)
	initSpriteBullet sprite, spriteB\x + spriteB\width / 2, spriteB\y
	sprite\x = sprite\x - sprite\width / 2
	sprite\targetSpeedY = -Abs(sprite\targetSpeedY * 2)
	sprite\targetHeight = 60
	sprite\speedLimit = Abs(sprite\targetSpeedY)
	sprite\targetRed = sprite\targetRed * 1.5
	sprite\targetGreen = sprite\targetGreen * 1.5
	sprite\targetBlue = sprite\targetBlue * 1.5
End Function

Function initSpriteBullet(sprite.typeSprite, x, y)
	initSpriteDefault sprite
	sprite\x = x
	sprite\y = y
	sprite\width = 8
	sprite\height = 30
	sprite\red = paletteMax
	sprite\green = 0
	sprite\blue = paletteMax
	sprite\speedY = -12
	sprite\speedLimit = Abs(sprite\speedY)
	sprite\class = classBullet
	sprite\targetGreen = paletteMax / 2
	sprite\targetBlue = 0
	sprite\colorSpeed = 5
	sprite\targetHeight = 12
	sprite\speedStep# = .4
End Function

Function initSpriteAlienBullet(spriteReference.typeSprite, sprite.typeSprite)
	initSpriteDefault sprite
	sprite\x = spriteReference\x + spriteReference\width / 2
	sprite\y = spriteReference\y + spriteReference\height / 2
	sprite\width = 18
	sprite\height = 6
	sprite\targetHeight = sprite\width
	sprite\targetWidth = sprite\height
	
	spriteSetColorToSprite spriteReference, sprite, -70
	spriteSetTargetColorToSprite spriteReference, sprite
	sprite\colorSpeed = 10
	sprite\speedY = 10
	sprite\speedLimit = Abs(sprite\speedY)
	sprite\class = classAlienBullet
End Function

Function initSpriteAlienSmall(sprite.typeSprite, x, y, speedX, speedY)
	initSpriteAlien(sprite.typeSprite)
	sprite\width = 32
	sprite\height = sprite\width
	sprite\x = x
	sprite\y = y
	sprite\speedX = speedX
	sprite\speedY = speedY
	sprite\class = classAlien
	sprite\speedLimit = 3
	sprite\red = 255
	sprite\green = 138
	sprite\blue = 21

	sprite\frameMax = 16
	
	sprite\image = getAnimImageFromCache("file\alien_small.bmp", sprite\width, sprite\height, 0, sprite\frameMax)
	sprite\frameWaitMax = 4

	sprite\subClass = subClassSmall
End Function

Function initSpriteAlien(sprite.typeSprite)
	initSpriteDefault sprite
	sprite\width = 48
	sprite\height = sprite\width
	sprite\frameMax = 16

	sprite\red = 255
	sprite\green = 169
	sprite\blue = 83
	
	sprite\speedLimit = 6
	
	If Rnd(100) >= 50
		sprite\x = screenLeft - (50 + Rnd(50))
		sprite\speedX = sprite\speedLimit
	Else
		sprite\x = screenWidth + (50 + Rnd(50))
		sprite\speedX = -sprite\speedLimit
	EndIf
	
	sprite\y = 6
	sprite\speedY = .6
	sprite\image = getAnimImageFromCache("file\alien.bmp", sprite\width, sprite\height, 0, sprite\frameMax)
	sprite\frameWaitMax = 4
	sprite\speedStep = .2
	sprite\class = classAlien
End Function

Function initSpriteStar(sprite.typeSprite)
	initSpriteDefault sprite
	sprite\x = Rnd(screenWidth)
	sprite\y = Rnd(screenHeight)
	size = Rnd(4)
	sprite\speedY = size * 2
	sprite\speedLimit = size * 2
	sprite\red = 100 + size * 30
	sprite\green = 100 + size * 30
	sprite\blue = 100 + size * 30
	sprite\width = size
	sprite\height = size
	sprite\class = classStar
	sprite\layer = layerDeepBack
End Function

Function initSpritePlayer(sprite.typeSprite)
	initSpriteDefault sprite
	sprite\x = screenWidth - sprite\width / 2
	sprite\y = screenHeight - sprite\height
	sprite\width = playerDefaultWidth
	sprite\class = classPlayer
	sprite\counterRestart = False
	sprite\red = 180
	sprite\green = 220
	sprite\blue = 255
	sprite\colorSpeed = 10
	spriteSetTargetColorToSelf sprite
	sprite\energy = 30
End Function

Function initSpriteBall(sprite.typeSprite)
	initSpriteDefault sprite
	sprite\width = 16
	sprite\height = 16
	sprite\red = 0
	sprite\green = 170
	sprite\blue = 255
	sprite\class = classBall
	sprite\speedX = 0
	sprite\speedY = 6
	sprite\speedLimit = ballSpeedLimit
	sprite\speedStep = .3
	sprite\x = screenWidth / 2 + Rnd(20) - 10
	sprite\y = -50
	sprite\counterMax = 4
	spriteSetTargetColorToSelf sprite
	sprite\energy = 10
	sprite\subClass = subClassStartBall
	sprite\layer = layerFront
End Function

Function initSparkles(x, y, max)
	For i = 1 To max
		initSpriteSparkle x, y, nothing, nothing, Rnd(6) - 3, -Rnd(4), paletteMax, paletteMax, paletteMax, nothing, defaultGravity, .4, 3, 0
	Next
End Function

Function initSparklesFromSprite(sprite.typeSprite)
	initColoredSparkles sprite\x, sprite\y, 18, sprite\red, sprite\green, sprite\blue
End Function

Function initSparklesAttacker(sprite.typeSprite)
	size = 6
	For xOff = 1 To sprite\width Step 6
		For yOff = 1 To sprite\height Step 6
			initSpriteSparkle sprite\x + xOff, sprite\y + yOff, size, size, sprite\speedX, sprite\speedY, sprite\red, sprite\green, sprite\blue, nothing, -9, .6, 9, subClassAttacker
		Next
	Next
End Function

Function initColoredSparkles(x, y, max, red, green, blue)
	For i = 1 To max
		initSpriteSparkle x, y, nothing, nothing, Rnd(6) - 3, -Rnd(4), red, green, blue, nothing, 0, .4, 3, 0
	Next
End Function

Function initSparklesExplosion(sprite.typeSprite, strong)
	xMid = sprite\x + sprite\width / 2
	yBottom = sprite\y + sprite\height / 2
	If strong
		size = 3
		For x = sprite\x To sprite\x + sprite\width Step 3
			For y = sprite\y To sprite\y + sprite\height Step 3
			xOff# = (x - xMid) / 4
			yOff# = (y - yBottom) / 2
			initSpriteSparkle x, y, size, size, xOff#, yOff#, sprite\red, sprite\green, sprite\blue, nothing, defaultGravity, .3, 20, 0
			Next
		Next
	Else
		size = 5
		For x = sprite\x To sprite\x + sprite\width Step 8
			For y = sprite\y To sprite\y + sprite\height Step 8
			xOff# = (x - xMid) / 4
			yOff# = (y - yBottom) / 2
			initSpriteSparkle x, y, size, size, xOff#, yOff#, sprite\red, sprite\green, sprite\blue, nothing, defaultGravity, .3, 20, 0
			Next
		Next
	EndIf
End Function

Function initSpriteSparkleBehind(sprite.typeSprite)
	If sprite\class = classBall
		initSpriteSparkle sprite\x + sprite\width / 2, sprite\y + sprite\height / 2, sprite\width, sprite\height, sprite\speedX, sprite\speedY, sprite\red -20, sprite\green -20, sprite\blue -20, nothing, defaultGravity, .4, 3, subClassPearl
	Else
		initSpriteSparkle behindX(sprite), behindY(sprite), nothing, nothing, sprite\speedX, sprite\speedY, sprite\red, sprite\green, sprite\blue, nothing, defaultGravity, .4, 3, 0
	EndIf
End Function

Function initSpriteSparkleBehindNegative(sprite.typeSprite)
	initSpriteSparkle behindX(sprite), behindY(sprite), nothing, nothing, -sprite\speedX / 2, -sprite\speedY / 2, sprite\red, sprite\green, sprite\blue, nothing, nothing, .4, 3, 0
End Function

Function initSpriteSparkle(x, y, width, height, speedX, speedY, red, green, blue, targetSpeedX, targetSpeedY, speedStep#, speedLimit, subClassN)
	sprite.typeSprite = New typeSprite
	initSpriteDefault sprite
	
	If width = nothing
		sprite\width = 2 + Rnd(2)
	Else
		sprite\width = width
	EndIf
	If height = nothing
		sprite\height = 2 + Rnd(2)
	Else
		sprite\height = height
	EndIf

	sprite\red = red
	sprite\green = green
	sprite\blue = blue
	sprite\speedX = speedX
	sprite\speedY = speedY
	sprite\targetSpeedX = targetSpeedX
	sprite\targetSpeedY = targetSpeedY
	sprite\speedLimit = speedLimit
	sprite\speedStep = speedStep#
	sprite\energy = 25 + Rnd(25)
	sprite\energyDirection = -1
	sprite\x = x + Rnd(6) - 3
	sprite\y = y + Rnd(6) - 3
	sprite\class = classSparkle
	sprite\colorSpeed = 10
	spriteSetTargetColorToBack sprite

	sprite\subClass = subClassN
	If sprite\subClass = subClassPearl
		sprite\targetWidth = 2
		sprite\targetHeight = 2
		sprite\x = x - sprite\width / 2
		sprite\y = y - sprite\height / 2
		sprite\layer = layerDeepBack
		sprite\colorSpeed = 5
		sprite\energy = 25
		sprite\shapeStep = .55
	ElseIf sprite\subClass = subClassAttacker
		sprite\energy = 50
		sprite\colorSpeed = 2.5
		sprite\targetWidth = 2
		sprite\targetHeight = 2
		sprite\shapeStep = .2
	EndIf
End Function

Function initSpritePlayerShade(sprite.typeSprite)
	initSpriteShade sprite\x, sprite\y, sprite\width, sprite\height, sprite\red / 2, sprite\green / 2, sprite\blue
End Function

Function initSpriteShade(x, y, width, height, red, green, blue)
	sprite.typeSprite = New typeSprite
	initSpriteDefault sprite
	sprite\x = x
	sprite\y = y
	sprite\width = width
	sprite\height = height
	sprite\red = red
	sprite\green = green
	sprite\blue = blue
	sprite\energy = 30
	sprite\energyDirection = -1
	sprite\class = classPlayerShade
	sprite\layer = layerBack
	spriteSetTargetColorToBack sprite
	sprite\colorSpeed = 10
End Function

Function initSpriteAttacker(sprite.typeSprite, i, leftOfScreen)
	sprite.typeSprite = New typeSprite
	initSpriteDefault sprite

	sprite\width = 32
	sprite\height = sprite\width

	sprite\y = -i * 20

	xOff = (sprite\width + 16) * i
	speedX = 6 + i
	If leftOfScreen
		sprite\x = screenLeft - xOff
		sprite\speedX = speedX
	Else
		sprite\x = screenWidth + xOff
		sprite\speedX = -speedX
	EndIf
	
	sprite\targetSpeedX = -sprite\speedX
	sprite\targetSpeedY = 3 + (5 - i)
	sprite\speedLimit = 20
	sprite\speedStep = .05
		
	sprite\red = 200
	sprite\green = 97
	sprite\blue = 47
		
	sprite\frameMax = 7
	
	sprite\image = getAnimImageFromCache("file\attacker.bmp", sprite\width, sprite\height, 0, sprite\frameMax)
	sprite\frameWaitMax = 4
	sprite\class = classAttacker
End Function

Function initSpriteDefault(sprite.typeSprite)
	sprite\x = Rnd(screenWidth)
	sprite\y = Rnd(screenHeight)
	sprite\speedX = 0
	sprite\speedY = 0
	sprite\speedLimit = 2
	sprite\speedStep = .01
	sprite\width = 16
	sprite\height = 16
	sprite\targetWidth = nothing
	sprite\targetHeight = nothing
	sprite\targetSpeedX = nothing
	sprite\targetSpeedY = nothing
	sprite\shapeStep = 1
	sprite\red = paletteMax
	sprite\green = paletteMax
	sprite\blue = paletteMax
	sprite\targetRed = nothing
	sprite\targetGreen = nothing
	sprite\targetBlue = nothing
	sprite\colorSpeed = 5
	sprite\energy = 10
	sprite\energyDirection = 0
	sprite\oldClass = 0
	sprite\class = 0
	sprite\counter = 0
	sprite\counterMax = 0
	sprite\counterRestart = True
	sprite\layer = layerFront
	sprite\subClass = 0
	sprite\targetX = nothing
	sprite\targetY = nothing
	sprite\frameMax = 0
	sprite\frameWaitMax = 0
	sprite\frame = firstFrame
End Function